;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; SCRIPT-FU-WATERMARK-BATCH
; Copyright (c) 2007-2008 Tharsice Demand <www.td-e.com>
; version 1.00  2007.11.12 for Gimp 2.4.0
; version 1.01  2008.06.13 for Gimp 2.4.2  a variable conversion is necessary, which wasn't b4
; version 1.02  2008.06.26 for Gimp 2.4.5  new while loop since 2.4.5 does not like the old one
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
;
;Copy of the license at http://td-e.com/site/gpl.php


(define (script-fu-watermark-batch 
srcpath destpath wmfile xmargini ymargini opai wmtext xmargint ymargint opat opatb wmfont wmfontsize wmfontcolor wmnocolor wmemboss toplef toprig botlef botrig centered)
  (let* 
    (
      (flatten 1)
      (filepattern "*.jpg")
      (pathpattern (string-append srcpath filepattern))
      (filelist (cadr (file-glob pathpattern 1)))
    )
    (while (not (null? filelist))
      (let* 
        (
          (filename (car filelist))
          (dirs (strbreakup filename "\\"))
          (depthofpath (length dirs))
          (shortfilename (nth (- depthofpath 1) dirs))
          (destfilename (string-append destpath shortfilename))

          (imagelist (gimp-file-load RUN-NONINTERACTIVE filename filename))
          (image (if (not (null? imagelist)) (car imagelist) 0))
          (drawablelist (gimp-image-get-active-layer image))
          (drawable (if (not (null? drawablelist)) (car drawablelist) 0))
        )

        (if (> drawable 0)
          (begin
            (script-fu-watermark-it 
             image drawable wmfile xmargini ymargini opai wmtext xmargint ymargint opat opatb wmfont wmfontsize wmfontcolor wmnocolor wmemboss toplef toprig botlef botrig centered)
            (set! drawable (car (gimp-image-get-active-layer image)))
            (gimp-file-save RUN-NONINTERACTIVE image drawable destfilename shortfilename)
            (gimp-image-delete image)
          )
        )
      )
      (set! filelist (cdr filelist))
    )
  )
)

(script-fu-register 
  "script-fu-watermark-batch"
  "<Toolbox>/Xtns/Batch/Watermark Batch..."
  "Batch processes the jpg files located at 'Source Path' with the script-fu Watermark-it. 
  Saves the results at 'Destination Path'."
  "T. Demand <td-e.com>"
  "T. Demand"
  "2007.11.12"
  ""
  SF-STRING      "Source Path"        "C:\\Users\\admin\\Pictures\\"
  SF-STRING      "Destination Path"   "C:\\Users\\admin\\Pictures\\out\\"
  SF-STRING      "Watermark image--------------" "C:\\Users\\admin\\Pictures\\watermark\\copy.png"
  SF-ADJUSTMENT  "Image X margin"     '(10 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Image Y margin"     '(10 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Image opacity"      '(60 1 100 1 10 0 1)
  SF-STRING      "Watermark text------------------" "(c)2007 FOTO HITS"
  SF-ADJUSTMENT  "Text X margin"      '(20 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Text Y margin"      '(20 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Text opacity"       '(90 1 100 1 10 0 1)
  SF-ADJUSTMENT  "Text perimeter opacity" '(40 0 100 1 10 0 1)
  SF-FONT        "Font"               "FreeSans Bold"
  SF-ADJUSTMENT  "Font Size (pixels)" '(20 6 1000 1 10 0 1)
  SF-COLOR       "Font color"         '(255 208 128)
  SF-TOGGLE      "No color i.e. lighten or darken image" FALSE
  SF-TOGGLE      "Emboss Text"        TRUE
  SF-OPTION      "TOP-LEFT"           '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "TOP-RIGHT"          '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "BOTTOM-LEFT"        '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "BOTTOM-RIGHT"       '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "CENTER"             '("No Watermark" "Image Watermark" "Text Watermark")
)

