;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; SCRIPT-FU-WATERMARK-IT
; version 1.00  2007.11.12 for Gimp 2.4
; Copyright (c) 2007 Tharsice Demand <www.td-e.com>
;
;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.
;
;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.
;
;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
;
;Copy of the license at http://td-e.com/site/gpl.php


(define (onewatermark 
img mainlayer wmposition floatinglayer textlayer textbglayer ximg yimg xtext ytext xtextbg ytextbg opai opat opatb wmtext wmfont wmfontsize wmemboss wmnocolor textbgwid textbghei)
  ;---1=TOP-LEFT---;---2=TOP-RIGHT---;---3=BOTTOM-LEFT---;---4=BOTTOM-RIGHT---;---5=CENTER---
  ;---0=none---;---1=img---;---2=text---
  (if (= wmposition 1)
    (begin 
      (set! floatinglayer (car (gimp-edit-paste mainlayer TRUE)))
      (gimp-layer-set-offsets floatinglayer ximg yimg)
      (gimp-layer-set-mode floatinglayer VALUE-MODE)
      (gimp-layer-set-opacity floatinglayer opai)
      (gimp-floating-sel-anchor floatinglayer)
    )
  )
  (if (= wmposition 2)
    (begin
      (if (> opatb 1)
        (begin
          (set! textbglayer (car (gimp-layer-new img textbgwid textbghei 1 "textbglayer" opatb NORMAL-MODE)))
          (gimp-image-add-layer img textbglayer 0)
          (gimp-layer-set-offsets textbglayer xtextbg ytextbg)
          (gimp-edit-fill textbglayer 0)
          (gimp-invert textbglayer)
          (if (= wmnocolor 1) (gimp-layer-set-mode textbglayer VALUE-MODE))
        )
      )
      (set! textlayer (car (gimp-text-fontname img -1 xtext ytext wmtext -1 TRUE wmfontsize 0 wmfont)))
      (if (= wmemboss 1) (plug-in-bump-map 1 img textlayer textlayer 135 30 3 0 0 0 0 1 0 0))
      (if (= wmnocolor 1) (gimp-layer-set-mode textlayer VALUE-MODE))
      (let* 
        (
          (my-shift (+ 1 (random (/ (+ 1 wmfontsize) 4))))
        )
        (plug-in-shift 1 img textlayer my-shift 1)
      )
      (gimp-layer-set-opacity textlayer opat)
    )
  )
)


(define (script-fu-watermark-it 
aimg adraw wmfile xmargini ymargini opai wmtext xmargint ymargint opat opatb wmfont wmfontsize wmfontcolor wmnocolor wmemboss toplef toprig botlef botrig centered)
  (let* 
    (
      (flatten 1)
      (fontheifac 1.1)
      (fontheifacbg 1.2)
      (old-fg (car (gimp-palette-get-foreground)))
      (img (car (gimp-drawable-get-image adraw)))
      (wid (car (gimp-image-width img)))
      (hei (car (gimp-image-height img)))

      (imgused (if (or (= toplef 1) (or (= toprig 1) (or (= botlef 1) (or (= botrig 1) (= centered 1))))) 1 0))
      (dirs (strbreakup wmfile "/"))
      (depthofpath (length dirs))
      (wmfilename (nth (- depthofpath 1) dirs))
      (lenfullname (string-length wmfile))
      (lenfilename (string-length wmfilename))
      (wmpathname (substring wmfile 0 (- lenfullname lenfilename)))

      (wmimage (if (= imgused 1) (car (gimp-file-load RUN-NONINTERACTIVE wmfile wmfilename)) 0))
      (wmdrawable (if (= imgused 1) (car (gimp-image-get-active-layer wmimage)) 0))
      (copied (if (= imgused 1) (gimp-edit-copy wmdrawable) 0))
      (imgwid (if (= imgused 1) (car (gimp-image-width wmimage)) 0))
      (imghei (if (= imgused 1) (car (gimp-image-height wmimage)) 0))
      (ximg1 xmargini)
      (yimg1 ymargini)
      (ximg2 (- wid (+ xmargini imgwid)))
      (yimg2 ymargini)
      (ximg3 xmargini)
      (yimg3 (- hei (+ ymargini imghei)))
      (ximg4 (- wid (+ xmargini imgwid)))
      (yimg4 (- hei (+ ymargini imghei)))
      (ximg5 (/ (- wid imgwid) 2))
      (yimg5 (/ (- hei imghei) 2))

      (textwid (car (gimp-text-get-extents-fontname wmtext wmfontsize 0 wmfont)))
      (xtext1 xmargint)
      (ytext1 (- ymargint (* wmfontsize 0.1)))
      (xtext2 (- wid (+ xmargint textwid)))
      (ytext2 (- ymargint (* wmfontsize 0.1)))
      (xtext3 xmargint)
      (ytext3 (- hei (+ ymargint (* wmfontsize fontheifac))))
      (xtext4 (- wid (+ xmargint textwid)))
      (ytext4 (- hei (+ ymargint (* wmfontsize fontheifac))))
      (xtext5 (/ (- wid textwid) 2))
      (ytext5 (/ (- hei (* wmfontsize fontheifac)) 2))
      (textbgwidpadding (* wmfontsize (- fontheifacbg fontheifac)))
      (textbgwid (+ textwid textbgwidpadding))
      (textbghei (* wmfontsize fontheifacbg))

      (xtextbg1 (- xtext1 (/ textbgwidpadding 2)))
      (ytextbg1 (- ytext1 textbgwidpadding))
      (xtextbg2 (- xtext2 (/ textbgwidpadding 2)))
      (ytextbg2 (- ytext2 textbgwidpadding))
      (xtextbg3 (- xtext3 (/ textbgwidpadding 2)))
      (ytextbg3 (- ytext3 textbgwidpadding))
      (xtextbg4 (- xtext4 (/ textbgwidpadding 2)))
      (ytextbg4 (- ytext4 textbgwidpadding))
      (xtextbg5 (- xtext5 (/ textbgwidpadding 2)))
      (ytextbg5 (- ytext5 textbgwidpadding))

      (textlayer1 0)
      (textlayer2 0)
      (textlayer3 0)
      (textlayer4 0)
      (textlayer5 0)

      (textbglayer1 0)
      (textbglayer2 0)
      (textbglayer3 0)
      (textbglayer4 0)
      (textbglayer5 0)

      (floatinglayer1 0)
      (floatinglayer2 0)
      (floatinglayer3 0)
      (floatinglayer4 0)
      (floatinglayer5 0)
    )

    (gimp-context-push)
    (gimp-image-undo-group-start img)
    (gimp-palette-set-foreground wmfontcolor)

    ;---1=TOP-LEFT---
    (onewatermark 
     img adraw toplef floatinglayer1 textlayer1 textbglayer1 ximg1 yimg1 xtext1 ytext1 xtextbg1 ytextbg1 opai opat opatb wmtext wmfont wmfontsize wmemboss wmnocolor textbgwid textbghei)

    ;---2=TOP-RIGHT---
    (onewatermark 
     img adraw toprig floatinglayer2 textlayer2 textbglayer2 ximg2 yimg2 xtext2 ytext2 xtextbg2 ytextbg2 opai opat opatb wmtext wmfont wmfontsize wmemboss wmnocolor textbgwid textbghei)

    ;---3=BOTTOM-LEFT---
    (onewatermark 
     img adraw botlef floatinglayer3 textlayer3 textbglayer3 ximg3 yimg3 xtext3 ytext3 xtextbg3 ytextbg3 opai opat opatb wmtext wmfont wmfontsize wmemboss wmnocolor textbgwid textbghei)

    ;---4=BOTTOM-RIGHT---
    (onewatermark 
     img adraw botrig floatinglayer4 textlayer4 textbglayer4 ximg4 yimg4 xtext4 ytext4 xtextbg4 ytextbg4 opai opat opatb wmtext wmfont wmfontsize wmemboss wmnocolor textbgwid textbghei)

    ;---5=CENTER---
    (onewatermark 
     img adraw centered floatinglayer5 textlayer5 textbglayer5 ximg5 yimg5 xtext5 ytext5 xtextbg5 ytextbg5 opai opat opatb wmtext wmfont wmfontsize wmemboss wmnocolor textbgwid textbghei)

    ;---FINISHING---
    (if (= imgused 1) (gimp-image-delete wmimage))
    (gimp-selection-none img)
    (if (= flatten 1) (gimp-image-flatten img) ())
    (gimp-displays-flush)

    (gimp-palette-set-foreground old-fg)
    (gimp-image-undo-group-end img)
    (gimp-context-pop)
  )
)


(script-fu-register 
  "script-fu-watermark-it"
  "<Image>/Filters/Decor/Watermark it..."
  "Apply image and text watermarks to any corner and/or to the center of an image."
  "Tharsice Demand <td-e.com>"
  "Tharsice Demand"
  "2007.11.12"
  "RGB RGBA GRAY GRAYA"
  SF-IMAGE       "Image"              0
  SF-DRAWABLE    "Drawable"           0
  SF-STRING      "Watermark image--------------" "C:\\Users\\admin\\Pictures\\watermark\\copy.png"
  SF-ADJUSTMENT  "Image X margin"     '(10 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Image Y margin"     '(10 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Image opacity"      '(60 1 100 1 10 0 1)
  SF-STRING      "Watermark text------------------" "(c)2007 Author Name"
  SF-ADJUSTMENT  "Text X margin"      '(20 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Text Y margin"      '(20 0 250 1 10 0 1)
  SF-ADJUSTMENT  "Text opacity"       '(90 1 100 1 10 0 1)
  SF-ADJUSTMENT  "Text perimeter opacity" '(40 0 100 1 10 0 1)
  SF-FONT        "Font"               "FreeSans Bold"
  SF-ADJUSTMENT  "Font Size (pixels)" '(20 6 1000 1 10 0 1)
  SF-COLOR       "Font color"         '(255 208 128)
  SF-TOGGLE      "No color i.e. lighten or darken image" FALSE
  SF-TOGGLE      "Emboss Text"        TRUE
  SF-OPTION      "TOP-LEFT"           '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "TOP-RIGHT"          '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "BOTTOM-LEFT"        '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "BOTTOM-RIGHT"       '("No Watermark" "Image Watermark" "Text Watermark")
  SF-OPTION      "CENTER"             '("No Watermark" "Image Watermark" "Text Watermark")
)